UIPackage
Menu

Framework

Change language

Boilerplate repo

Polar Bar Chart

polar-bar-chartui

React mirror of @uipkge/polar-bar-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/polar-bar-chart.json
Named registry:npx shadcn@latest add @uipkge-react/polar-bar-chartInstalls to:components/ui/charts/polar-bar-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data{ category: string; value: number }[]required
heightnumber | string320optional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/polar-bar-chart/PolarBarChart.tsx2.5 kB
    'use client'
    
    import * as React from 'react'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme, mergeOptionBlock } from '../useChartTheme'
    
    // PolarBarChart
    // ─────────────────────────────────────────────────────────────────────────
    
    export interface PolarBarChartProps {
      data: { category: string; value: number }[]
      height?: number | string
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const PolarBarChart = React.forwardRef<HTMLDivElement, PolarBarChartProps>(
      ({ data, height = 320, option, className, ariaLabel }, ref) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const series = [
            {
              type: 'bar',
              coordinateSystem: 'polar',
              data: data.map((d) => d.value),
              colorBy: 'data',
              roundCap: true,
              itemStyle: { borderRadius: 6 },
            },
          ]
          const userOption: any = option ?? {}
          const {
            series: userSeries,
            polar: userPolar,
            angleAxis: userAngle,
            radiusAxis: userRadius,
            tooltip: userTooltip,
            legend: userLegend,
            ...userRest
          } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
    
          return {
            color: theme.colors,
            polar: mergeOptionBlock({ radius: ['18%', '78%'] }, userPolar),
            angleAxis: mergeOptionBlock(
              { type: 'value', startAngle: 90, axisLabel: { color: theme.textColor, fontSize: 10 } },
              userAngle,
            ),
            radiusAxis: mergeOptionBlock(
              { type: 'category', data: data.map((d) => d.category), axisLabel: { color: theme.textColor, fontSize: 11 } },
              userRadius,
            ),
            tooltip: mergeOptionBlock(
              {
                trigger: 'item',
                backgroundColor: theme.tooltipBg,
                borderColor: theme.tooltipBorder,
                textStyle: { color: theme.tooltipText, fontSize: 12 },
              },
              userTooltip,
            ),
            legend: userLegend?.show === false ? undefined : mergeOptionBlock({ show: false }, userLegend),
            series: mergedSeries,
            ...userRest,
          }
        }, [data, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    PolarBarChart.displayName = 'PolarBarChart'
    
  • components/ui/charts/polar-bar-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/polar-bar-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Polar Bar Chart

polar-bar-chartui

Radial bar chart on the ECharts polar coordinate system. Categories around the radius axis with rounded caps. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/polar-bar-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/polar-bar-chartInstalls to:app/components/ui/charts/polar-bar-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
data{ category: string; value: number }[]required
heightnumber | string320optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/polar-bar-chart/PolarBarChart.vue2.7 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { BarChart as EChartsBarChart } from 'echarts/charts'
    import { PolarComponent, TooltipComponent, LegendComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import {
      chartColors,
      chartTextColor,
      chartTooltipBg,
      chartTooltipBorder,
      chartTooltipText,
      mergeOptionBlock,
    } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsBarChart, PolarComponent, TooltipComponent, LegendComponent])
    
    interface Props {
      data: { category: string; value: number }[]
      height?: number | string
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      height: 320,
    })
    
    const mergedOption = computed(() => {
      const series = [
        {
          type: 'bar',
          coordinateSystem: 'polar',
          data: props.data.map((d) => d.value),
          colorBy: 'data',
          roundCap: true,
          itemStyle: { borderRadius: 6 },
        },
      ]
    
      const userOption: any = props.option ?? {}
      const {
        series: userSeries,
        polar: userPolar,
        angleAxis: userAngle,
        radiusAxis: userRadius,
        tooltip: userTooltip,
        legend: userLegend,
        ...userRest
      } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
    
      return {
        color: chartColors.value,
        polar: mergeOptionBlock({ radius: ['18%', '78%'] }, userPolar),
        angleAxis: mergeOptionBlock(
          { type: 'value', startAngle: 90, axisLabel: { color: chartTextColor.value, fontSize: 10 } },
          userAngle,
        ),
        radiusAxis: mergeOptionBlock(
          {
            type: 'category',
            data: props.data.map((d) => d.category),
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
          },
          userRadius,
        ),
        tooltip: mergeOptionBlock(
          {
            trigger: 'item',
            backgroundColor: chartTooltipBg.value,
            borderColor: chartTooltipBorder.value,
            textStyle: { color: chartTooltipText.value, fontSize: 12 },
          },
          userTooltip,
        ),
        legend: userLegend?.show === false ? undefined : mergeOptionBlock({ show: false }, userLegend),
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/polar-bar-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/polar-bar-chart.json